//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * TEh`wb_
 * @author Junpee
 */

#ifndef SOUND_DEFINITION_H_
#define SOUND_DEFINITION_H_

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * TEh`
 */
class SoundDefinition{
public:
	/// ftHgtH[JX
	static const int defaultFocus;

	/// Xg[obt@̕b
	static const float streamBufferLength;

	/// W
	static const float distanceFactor;

	//--------------------------------------------------------------------------
	/// vC}obt@̃rbg(8 or 16)
	static const u_int primaryBufferBit = 16;// 8 16

	/// vC}obt@̃TvO[g
	static const u_int primaryBufferRate = 44100;// 22050 44100

	/// vC}obt@̓XeI
	static const bool primaryBufferStereo = true;

	/// ZJ_obt@̃rbg(8 or 16)
	static const u_int secondaryBufferBit = 16;// 8 16

	/// ZJ_obt@̃TvO[g
	static const u_int secondaryBufferRate = 44100;// 22050 44100

private:
	// RXgN^̉B
	SoundDefinition();

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of SOUND_DEFINITION_H_
//------------------------------------------------------------------------------
