//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ϊJ}l[Wwb_
 * @author Junpee
 */

#ifndef TRANSLATION_CAMERA_MANAGER_H_
#define TRANSLATION_CAMERA_MANAGER_H_

#include <Core/Container/HashMap.h>
#include <Core/Container/ArrayList.h>
#include <Translator/Camera/TranslationCamera.h>

namespace LampForMaya{

class TranslationModelManager;

//------------------------------------------------------------------------------
/**
 * ϊJ}l[W
 */
class TranslationCameraManager{
public:
	/**
	 * RXgN^
	 */
	TranslationCameraManager();

	/**
	 * fXgN^
	 */
	virtual ~TranslationCameraManager();

	/**
	 * J̎W
	 * @return true
	 */
	virtual bool collectCameras();

	/**
	 * Aj[V̎W
	 * @return true
	 */
	virtual bool collectAnimations();

	/**
	 * Lampւ̕ϊ
	 * @param scene ϊV[
	 * @return true
	 */
	virtual bool convertToLamp(Scene* scene) const;

	/**
	 * Aj[V̕ϊ
	 * @param animationManager Aj[V}l[W
	 * @param animationSet Aj[VZbg
	 * @return true
	 */
	virtual bool convertAnimation(
		AnimationManager* animationManager, AnimationSet* animationSet);

	/**
	 * NA
	 * @return 폜IuWFNg
	 */
	virtual int clear();

	/**
	 * J̎擾
	 * @return J
	 */
	virtual int getCount() const{ return array_.getCount(); }

	/**
	 * J̎擾
	 * @param index J̃CfNX
	 * @return J
	 */
	virtual TranslationCamera* get(int index) const{
		return array_.get(index);
	}

	/**
	 * J̌
	 * @param name J
	 * @return J
	 */
	virtual TranslationCamera* search(String name) const{
		return database_.get(name);
	}

protected:
	/**
	 * J̉
	 * @param dagPath DAGpX
	 * @return true
	 */
	virtual bool analysisCamera(MDagPath dagPath);

private:
	// Rs[RXgN^̉B
	TranslationCameraManager(const TranslationCameraManager& copy);

	// Rs[̉B
	void operator =(const TranslationCameraManager& copy);

	// Jf[^x[X
	Lamp::HashMap<String, TranslationCamera*> database_;
	// Jz
	ArrayList<TranslationCamera*> array_;

};

//------------------------------------------------------------------------------
} // End of namespace LampForMaya
#endif // End of TRANSLATION_CAMERA_MANAGER_H_
//------------------------------------------------------------------------------
